%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Where_Is_My_Bolt(Shank_Element_ID)

% Функция выводит диагностические сообщения о причине нераспознавания болта,
% содержащего балочный элемент с номером Shank_Element_ID в стержне болта

global Diagnostic_Data;

global DB_ELEMENTS;
global AT_ELEMENTS;

global DB_FASTENERS;

if (~DB_Elm_Exist(Shank_Element_ID))
    fprintf (1, '\nЭлемент с номером %i отсутствует в загруженной из bdf файла модели!\n\n', Shank_Element_ID);
    return;
end

if (~strcmp(DB_ELEMENTS{AT_ELEMENTS(Shank_Element_ID)}.type ,'Bar'))
    fprintf (1, '\nЭлемент с номером %i не является балочным элементом!\n\n', Shank_Element_ID);
    return;
end

if (isempty(Diagnostic_Data.Circular_Cross_Section_Elements) || ...
    isempty(Diagnostic_Data.Recognized_Chains) || ...
    isempty(Diagnostic_Data.Chain_Screening_Marker_Table) || ...
    isempty(Diagnostic_Data.Chain_Screening_Reason_Data))

    fprintf (1, '\nРаспознавание крепежа в модели не было запущено, либо было прервано в результате ошибки!\n\n');
    return;
    
end

if (~ismember(Shank_Element_ID, Diagnostic_Data.Circular_Cross_Section_Elements))
    fprintf (1, '\nЭлемент крепежа, содержащий балочный элемент с номером %i в стержне болта, не был распознан по следующей причине:\n', Shank_Element_ID);
    fprintf (1, ' ---> Элемент с номером %i не является элементом c круглым поперечным сечением.\n\n', Shank_Element_ID);
    return;
end

Find_flag = 0;

for i=1:size(Diagnostic_Data.Recognized_Chains,1)
    if (ismember(Shank_Element_ID, Diagnostic_Data.Recognized_Chains{i}.Elements))
        Find_flag = 1;
        Chain_index = i;
        break;
    end
end

if (Find_flag == 0)
    fprintf (1, '\nЭлемент крепежа, содержащий балочный элемент с номером %i в стержне болта, не был распознан по следующей причине:\n', Shank_Element_ID);
    fprintf (1, '---> Элемент с номером %i не вошел ни в одну из цепочек балочных элементов.\n', Shank_Element_ID);
    fprintf (1, 'Это означает, что последовательность балочных элементов с тем же property set, что и у исходного,\n');
    fprintf (1, 'не образует цепочку, то есть либо разветвляется, либо образует замкнутое кольцо.\n\n');
    return;
end

if (Diagnostic_Data.Chain_Screening_Marker_Table(Chain_index) == 1)
    
    fprintf (1, '\nЭлемент крепежа, содержащий балочный элемент с номером %i в стержне болта, не был распознан по следующей причине:\n', Shank_Element_ID);
    fprintf (1, '---> %s\n\n', Diagnostic_Data.Chain_Screening_Reason_Data{Chain_index});
    
else
    
    Find_flag_2 = 0;
    
    for i=1:size(DB_FASTENERS,1)
        if (ismember(Shank_Element_ID, DB_FASTENERS{i}.Shank_elements))
            Find_flag_2 = 1;
            break;
        end
    end
    
    if (Find_flag_2 == 1)
        
        switch DB_FASTENERS{i}.topology
            case 'bar_fastener'
                Fastener_type = 'балочный болт';
            case 'rutman_fastener'
                Fastener_type = 'болт Рутмана';
            otherwise
                Fastener_type = [];
        end
        
    else
        
        Fastener_type = [];
        
    end
    
    fprintf (1, '\nЭлемент крепежа, содержащий балочный элемент с номером %i в стержне болта, распознан успешно (тип: %s).\n\n', Shank_Element_ID, Fastener_type);
    
end
